
#include "m_pd.h"
#include "math.h"

static t_class *distance_class;
/* static tclass pointer - Main handle for class*/


typedef struct _distance {
    t_object x_obj;
    t_float a, b, c, d;
    t_inlet *in_2;
    t_outlet *out;
    /* pointers to two inlets and one outlet*/
    
}t_distance;


/* take in two float values, compare, then output 1 value or another value */
void distance_input(t_distance *x, t_floatarg f1){
    
    float y = x->d;
    
    x->b = sqrtf(((0 - f1)*(0 - f1)) + (0 - y)*((0 - y)));
    
    outlet_float(x->out, x->b);
}


/* initializer */
void *distance_new(void){
    t_distance *x = (t_distance *) pd_new(distance_class); /*this is pointer*/
    
    //Create inlets
    x->in_2 = floatinlet_new(&x->x_obj, &x->d);
    
    //Create outlet
    x->out = outlet_new(&x->x_obj, &s_float);
    
    
        return (void *)x;
}


void distance_free(t_distance *x){
  
    inlet_free(x->in_2);
    outlet_free(x->out);
}


void distance_setup(void){
    
    /* initialize class*/
    distance_class = class_new(gensym("distance"), (t_newmethod)distance_new,
                    (t_method)distance_free, sizeof(t_distance),CLASS_DEFAULT,A_DEFFLOAT, 0);
    class_addfloat(distance_class, distance_input);
    class_sethelpsymbol(distance_class, gensym("distance"));
}




